﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace case1_subeditor
{

    public class mySubEd : Form, FarPoint.Win.Spread.CellType.ISubEditor
    {

        public event EventHandler ValueChanged;
        public event EventHandler CloseUp;
        private TextBox txt = null;
        private Button BtnOk = null;
        private Button BtnCancel = null;

        public mySubEd()
        {
            FormBorderStyle = FormBorderStyle.FixedSingle;
            MaximizeBox = false;
            MinimizeBox = false;
            ControlBox = false;
            txt = new TextBox();
            BtnOk = new Button();
            BtnCancel = new Button();
            txt.Location = new Point(0, 0);
            txt.Size = new Size(110, 200);
            txt.ForeColor = Color.Red;
            BtnOk.Location = new Point(3, 75);
            BtnOk.Size = new Size(50, 25);
            BtnOk.Text = "OK";
            BtnOk.ForeColor = Color.Red;
            BtnCancel.Location = new Point(57, 75);
            BtnCancel.Size = new Size(50, 25);
            BtnCancel.Text = "Cancel";
            BtnCancel.ForeColor = Color.Red;
            Controls.Add(txt);
            Controls.Add(BtnOk);
            Controls.Add(BtnCancel);
            Text = "Editor";
            BtnOk.Click += new EventHandler(OK_Clicked);
            BtnCancel.Click += new EventHandler(Cancel_Clicked);
            txt.TextChanged += new EventHandler(txt_TextChanged);
        }

        private void OK_Clicked(object sender, EventArgs e)
        {
            if (ValueChanged != null)
                ValueChanged(this, EventArgs.Empty);
            if (CloseUp != null)
                CloseUp(this, EventArgs.Empty);
        }

        private void Cancel_Clicked(object sender, EventArgs e)
        {
            if (CloseUp != null)
                CloseUp(this, EventArgs.Empty);
        }

        private void txt_TextChanged(object sender, EventArgs e)
        {
            Text = txt.Text;
        }

        public Point GetLocation(Rectangle rect)
        {
            Point pt = new Point(0);
            Size sz = GetPreferredSize();
            pt.Y = (Screen.PrimaryScreen.WorkingArea.Height / 2) - (sz.Height / 2);
            pt.X = (Screen.PrimaryScreen.WorkingArea.Width / 2) - (sz.Width / 2);
            return pt;
        }
        public Control GetSubEditorControl()
        {
            return this;
        }
        public object GetValue()
        {
            return txt.Text;
        }
        public void SetValue(object value)
        {
            value = txt.Text;
        }
        public Size GetPreferredSize()
        {
            return new Size(115, 130);
        }
    }
    public partial class Form1 : Form
    {
        FarPoint.Win.Spread.CellType.TextCellType t;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            t = new FarPoint.Win.Spread.CellType.TextCellType();
            t.DropDownButton = true;
            t.SubEditor = new mySubEd();
            fpSpread1.ActiveSheet.Columns[0].CellType = t;
            fpSpread1.EditModeOn += new EventHandler(fpSpread1_EditModeOn);
            fpSpread1.LeaveCell += new FarPoint.Win.Spread.LeaveCellEventHandler(fpSpread1_LeaveCell);
        }

        void fpSpread1_LeaveCell(object sender, FarPoint.Win.Spread.LeaveCellEventArgs e)
        {
            t.ReadOnly = false;
        }

        void fpSpread1_EditModeOn(object sender, EventArgs e)
        {
            t.ShowSubEditor();
            t.ReadOnly = true;
        }
    }
}
